<?php

if (!defined('UD_CENTRAL_DIR')) die('Security check');

$uc_debug_level = 0;
if (@constant('UPDRAFTCENTRAL_DEBUG_LEVEL')) {
	$uc_debug_level = UPDRAFTCENTRAL_DEBUG_LEVEL;
} elseif  (@constant('UPDRAFTCENTRAL_DEV_ENVIRONMENT')) {
	$uc_debug_level = 1;
}

return array(
	'ajaxurl' => admin_url('admin-ajax.php', 'relative'),
	'debug_level' => $uc_debug_level,
	'updraftcentral_dashboard_nonce' => wp_create_nonce('updraftcentral_dashboard_nonce'),
	'error' => __('Error', 'updraftcentral'),
	'communications_error' => __('Communications error', 'updraftcentral'),
	'add_site' => __('Add Site', 'updraftcentral'),
	'advanced_options' => __('Advanced options', 'updraftcentral'),
	'could_not_parse' => __('The response was not understood.', 'updraftcentral').' '.__('You can check the browser JavaScript console for more information.', 'updraftcentral'),
	'unknown_response' => __('The response was not understood (no message included).', 'updraftcentral').' '.__('You can check the browser JavaScript console for more information.', 'updraftcentral'),
	'remove_site' => __('Remove site', 'updraftcentral'),
	'really_delete_site' => __('Do you really wish to delete this site from your dashboard?', 'updraftcentral'),
	'what_remote_running' => __('This site is running WordPress version %s (PHP %s, MySQL %s) and UpdraftPlus version %s (UDRPC version %s)', 'updraftcentral'),
	'updraftcentral_version' => __('UpdraftCentral version', 'updraftcentral'),
	'js_exception_occurred' => __("An error occurred - you may find more information in your web browser's JavaScript console.", 'updraftcentral'),
	'test_other_connection_methods' => __('Follow this link to test alternative connection methods', 'updraftcentral'),
	'test_connection_methods' => __('Test connection methods', 'updraftcentral'),
	'testing' => __('Testing...', 'updraftcentral'),
	'failed' => __('Failed', 'updraftcentral'),
	'succeeded' => __('Succeeded.', 'updraftcentral'),
	'general_js_comms_failure' => __('There was an error in contacting the remote site.', 'updraftcentral').' '.__("You should check that the remote site is online, is not firewalled, has remote control enabled, and that no security module is blocking the access. Then, check the logs on the remote site and your browser's JavaScript console.", 'updraftcentral').' '.__('If none of that helps, then you should try re-adding the site with a fresh key.', 'updraftcentral'),
	'general_ajax_comms_failure' => __('There was an error in contacting either the dashboard server or the remote site.', 'updraftcentral').' '.__("You should check that the dashboard website is online, and that the remote site is online, is not firewalled, has remote control enabled, and that no security module is blocking the access. Then, check the logs on the remote site and your browser's JavaScript console.", 'updraftcentral').' '.__('If none of that helps, then you should try re-adding the site with a fresh key.', 'updraftcentral'),
	'comms_failure_timeout' => __('There was an error in contacting the remote site.', 'updraftcentral').' '.__('The request did not complete in a reasonable amount of time.', 'updraftcentral').' '.__('You should check that the remote site is online, is not firewalled, has remote control enabled, and that no security module is blocking the access. Then, check the logs on the remote site.', 'updraftcentral'),
	'timeout' => __('timeout', 'updraftcentral'),
	'comms_failure_unauthorised' => __('There was an error in contacting the remote site.', 'updraftcentral').' '.__("The request to the remote site was blocked by the site's webserver as unauthorized.", 'updraftcentral'),
	'comms_failure_unauthorised_by_browser' => __('There was an error in contacting the remote site.', 'updraftcentral').' '.__('The request to the remote site was blocked by your web browser as unauthorized.', 'updraftcentral'),
	'http_response_status' => __('HTTP response status code', 'updraftcentral'),
	'error_code' => __('Error code', 'updraftcentral'),
	'site' => __('Site', 'updraftcentral'),
	'open_site_configuration' => __('Open site configuration', 'updraftcentral'),
	'description' => __('Description', 'updraftcentral'),
	'go' => __('Go', 'updraftcentral'),
	'close' => __('Close', 'updraftcentral'),
	'edit' => __('Edit', 'updraftcentral'),
	'edit_site_configuration' => __('Edit site configuration', 'updraftcentral'),
	'phpinfo' => __('PHP installation information', 'updraftcentral'),
	'paste_key' => __('To connect to a remote site, paste its key here:', 'updraftcentral'),
	'unknown_key' => __('The remote site did not recognise the communications key - you are recommended to delete and re-create it.', 'updraftcentral'),
	'already_have' => __('The remote site has already received the communications key', 'updraftcentral'),
	'go_here_for_help_including_screenshots' => __('Follow this link for help, including a video and screenshots', 'updraftcentral'),
	'go_here_for_connection_help' => __('Go here for help in trouble-shooting connection issues', 'updraftcentral'),
	'http_authentication_if_any' => __('HTTP authentication (for sites protected by a password)', 'updraftcentral'),
	'http_authentication_method' => __('Authentication method'),
	'http_username' => __('HTTP username', 'updraftcentral'),
	'http_password' => __('HTTP password', 'updraftcentral'),
	'basic' => __('Basic', 'updraftcentral'),
	'digest' => __('Digest', 'updraftcentral'),
	'send_cors_headers' => __('Send CORS headers', 'updraftcentral'),
	'send_cors_headers_explanation' => __('CORS headers should normally be turned on, so that UpdraftCentral on the remote site sends these necessary headers. You would only turn it off if you have set something else up to manually add them (which may be necessary for you to do if you are using HTTP authentication).', 'updraftcentral'),
	'digest_auth_not_supported' => __('The remote site is protected by HTTP digest authentication, which UpdraftCentral does not support in this connection mode (via mothership).', 'updraftcentral'),
	'connection_method' => __('Connection method', 'updraftcentral'),
	'test_not_possible_in_current_mode' => __('These tests cannot currently be run. You must first change and save the site configuration to take it out of the "Via mothership (dashboard webserver), encryption performed at the mothership" mode, in order to be able to perform the connection tests. This is because in the current mode, some of the information for testing direct connections has not been shared with the browser, to enhance security.', 'updraftcentral'),
	'run_connection_test' => __('Run a connection method test by following this link', 'updraftcentral'),
	'get_advanced_connection_help' => __('Get help on complicated setups and connection methods at this link.', 'updraftcentral'),
	'http_must_go_via_mothership' => sprintf(__('Because of %s, any connections to http sites must go via the mothership (dashboard webserver) - and the option chosen here will make no difference', 'updraftcentral'), '<a target="_blank" href="https://developer.mozilla.org/en-US/docs/Security/Mixed_content">'.__('web browser security restrictions', 'updraftcentral').'</a>'),
	'direct' => __('Direct', 'updraftcentral'),
	'direct_default_auth' => __('Direct when possible (authentication method chosen automatically)', 'updraftcentral'),
	'direct_jquery_auth' => __('Direct when possible (authentication via jQuery)', 'updraftcentral'),
	'direct_manual_auth' => __('Direct when possible (manually constructed authentication)', 'updraftcentral'),
	'not_yet_begun' => __('Not yet begun', 'updraftcentral'),
	'via_mothership_short' => __('Via mothership (encrypted from the browser)', 'updraftcentral'),
	'via_mothership_encrypting_short' => __('Via mothership (encrypted at the mothership)', 'updraftcentral'),
	'via_mothership' => __('Via mothership (slower, but better compatibility with some awkward setups)', 'updraftcentral'),
	'via_mothership_encrypting' => __('Via mothership, encryption performed at the mothership (useful for slow browsers, but less secure)', 'updraftcentral'),
	'localdev_can_work_better_with_https' => __('Browser security restrictions preventing https dashboards contacting non-https sites may be involved here. You could try setting up https (i.e. SSL) for your site-local website, visiting its dashboard over https, and getting a new key for it.', 'updraftcentral'),
	'method' => __('Method (in recommended order)', 'updraftcentral'),
	'result' => __('Result', 'updraftcentral'),
	'not_possible_browser_restrictions' => __('Not possible (due to browser security restrictions on non-https sites)', 'updraftcentral'),
	'best_method' => __('This is the best connection method.', 'updraftcentral'),
	'recommend_keep' => __('You are recommended to continue using it.', 'updraftcentral'),
	'recommend_use' => __('You are recommended to use it.', 'updraftcentral'),
	'current_method' => __('This is the current method.', 'updraftcentral'),
	'switch_to' => __('Switch to using this method', 'updraftcentral'),
	'settings' => __('Settings', 'updraftcentral'),
	'save_settings' => __('Save settings', 'updraftcentral'),
	'debugging_level' => __('Debugging level', 'updraftcentral'),
	'debugging_level_this_session' => __("for this session only - controls the amount of output in the web browser's console", 'updraftcentral'),
	'window_may_be_blocked' => __('The request to open a new browser window/tab was made, but that window/tab was not immediately found - if you have a pop-up blocker, then please check it (e.g. it may be showing something in the browser address bar).', 'updraftcentral'),
	'open_new_window' => __('Opening a new window/tab', 'updraftcentral'),
	'updraftcentral_help' => __('UpdraftCentral Help', 'updraftcentral'),
	'follow_one_for_help' => __('Follow one of these links to get help with UpdraftCentral', 'updraftcentral'),
	'how_to_install' => __('How to install UpdraftCentral', 'updraftcentral'),
	'how_to_add_site' => __('How to add a site to UpdraftCentral', 'updraftcentral'),
	'faqs' => __('Frequently asked questions', 'updraftcentral'),
	'make_a_suggestion' => __('Make a suggestion / feature request', 'updraftcentral'),
	'paid_support_requests' => __('Paid support requests', 'updraftcentral'),
	'support_forum' => __('Support forum', 'updraftcentral'),
	'site_unlicensed_message' => apply_filters('updraftcentral_site_unlicensed_message', __('You have more sites in your dashboard than licences. As a result, you cannot perform actions on this site.', 'updraftcentral').' '.__('You will need to obtain more licences, or remove some sites.', 'updraftcentral')),
	'browser_cache' => __('UC browser cache', 'updraftcentral'),
	'empty' => __('Empty'),
	'log_contents' => __('Log contents', 'updraftcentral'),
	'cache_no_contents' => __('The UpdraftCentral browser cache currently has no contents', 'updraftcentral'),
	'cache_emptied' => __('The UpdraftCentral browser cache was emptied - %s items were removed', 'updraftcentral'),
	'cache_contents_logged' => __('The UpdraftCentral browser cache contents have been logged in the browser developer console.', 'updraftcentral'),
	// Text messages corresponding to returned error codes for RPC calls
	'rpcerrors' => array(
		'ud_get_fragment_could_not_return' => __('The site could not return the requested information - perhaps you need to update it to a more recent UpdraftPlus version?', 'updraftcentral'),
		'unknown_rpc_command' => __('The remote site did not recognise the command.', 'updraftcentral').' '.sprintf(__('Possibly you need to update the remote site to a more recent %s version.', 'updraftcentral'), 'UpdraftPlus'),
	),
	'unsupported_browser' => __('Your web browser lacks capabilities that UpdraftCentral requires, and thus is not supported. Please update your browser to the latest version.', 'updraftcentral'),
	'search' => __('Search', 'updraftcentral'),
	'failed_credentials_heading' => __('Invalid Credentials', 'updraftcentral'),
	'failed_credentials' => __('The credentials you entered did not give the desired access. Please check that your server is properly configured for access, and that you have entered the correct credentials.', 'updraftcentral'),
	'credentials_ok' => __('Credentials appears to be valid.', 'updraftcentral'),
	'tasks_queue_empty' => __('There are currently no tasks available to execute.', 'updraftcentral'),
	'current_progress' => __('Current Progress', 'updraftcentral'),
	'process_completed' => __('The update process has completed. Refreshing...', 'updraftcentral'),
	'processing' => __('Processing', 'updraftcentral'),
	'process_aborted' => __('Process halted due to errors.', 'updraftcentral'),
/*
	'' => __('', 'updraftcentral'),
*/
);
